<?php
class factureazame
{
    public $apiurl;
    public $apikey;

    public function __construct()
    {
        $this->apiurl = trim(get_option('factureazame_apiurl'), '/ ');
        $this->apikey = trim(get_option('factureazame_apikey'));
    }

    function CallMethod($function, $parameters = [], $verb = 'GET', $headers = array()) {
	    $args = array(
		    'headers' => array_merge($headers, array('Authorization' => 'Bearer ' . $this->apikey)),
			'sslverify' => false
	    );

	    $response = null;

	    if ($verb == 'GET') {
		    $response = wp_remote_get($this->apiurl . '/' . $function, $args);
	    } elseif ($verb == 'POST') {
			$args['body'] = $parameters;
		    $response = wp_remote_post($this->apiurl . '/' . $function, $args);
	    } elseif ($verb == 'DELETE') {
		    $args['method'] = 'DELETE';
	    	$response = wp_remote_request($this->apiurl . '/' . $function, $args);
	    } else {
	    	return null;
	    }

	    $status = wp_remote_retrieve_response_code($response);
	    $data = wp_remote_retrieve_body($response);

	    if ($status == '200') {
		    if (strpos($response['headers']['content-type'], 'application/json') !== false) {
			    return json_decode($data, true);
		    } else {
		    	return $data;
		    }
	    } else {
		    echo '<pre>';
		    echo 'Status<br/>';
		    print_r(array(
			    'status' => $status,
			    'method' => $function,
			    'verb' => $verb,
			    'params' => $parameters,
			    'data' => $data
		    ));
		    echo 'CURL Error<br/>';
		    print_r($response);
		    echo '</pre>';
	    }
    }
}