function isloading(item) {
    (function($) {
        $('#' + item).attr('disabled', 1).html('se incarca...');
    })(jQuery);
}

function factureazame_check_invoices(type = 'invoice') {
    (function($) {
        $(function() {
            $('table.wp-list-table.posts .column-factureazame-' + type).remove();
            $('table.wp-list-table.posts thead tr').append('<th class="column-factureazame-' + type + '"><strong>Facturi ' + (type == 'invoice' ? 'fiscale' : 'proforme') + '</strong></th>');
            $('table.wp-list-table.posts tfoot tr').append('<th class="column-factureazame-' + type + '"></th>');

            var order_ids = [];
            $('input[name="post[]"]').each(function() {
                var order_id = $(this).val();
                $('#post-' + order_id).append('<td class="column-factureazame-' + type + '"><div id="fme-' + type + '-' + order_id + '" style="line-height:20px; margin-top:5px; margin-right:10px"></div></td>');
                order_ids.push(order_id);
            });

            $.ajax({
                type: 'POST',
                data: { action: 'factureazame_template_bulk', order_ids: order_ids, type: type },
                url: 'admin-ajax.php',
                dataType: 'json',
                success: function(data) {
                    data.forEach((i) => {
                        $('#fme-' + type + '-' + i.order_id).html(i.html);
                    });
                }
            });
        });
    })(jQuery);
}

function factureazame_template(type = 'invoice', order_id = null, slim = false, callback = false) {
    (function($) {
        $.ajax({
            type: 'POST',
            data: { action: 'factureazame_template', type: type, order_id: order_id, slim: slim },
            url: 'admin-ajax.php',
            success: function(data) {
                if (callback)
                    callback(data);
                else
                    $('#factureazame-' + type).html(data);
            }
        });
    })(jQuery);
}

function factureazame_issue(type = 'invoice', order_id, callback = false) {
    (function($) {
        if (!callback)
            isloading('button_factureazame_issue_' + type);

        $.ajax({
            type: 'POST',
            data: { action: 'factureazame_issue_invoices', type: type, order_ids: [order_id] },
            url: 'admin-ajax.php',
            success: function() {
                if (callback)
                    callback();
                else
                    factureazame_template(type, order_id);
            }
        });
    })(jQuery);
}

function factureazame_email(type = 'invoice', order_id, invoice_hash, callback = false) {
    (function($) {
        if (!callback)
            isloading('button_factureazame_email_' + type);

        $.ajax({
            type: 'POST',
            data: { action: 'factureazame_email_invoice', type: type, order_id: order_id, invoice_hash: invoice_hash },
            url: 'admin-ajax.php',
            success: function() {
                if (callback)
                    callback();
                else
                    factureazame_template(type, order_id);
            }
        });
    })(jQuery);
}

function factureazame_cancel(type = 'invoice', order_id, invoice_hash, callback = false) {
    (function($) {
        if (!callback)
            isloading('button_factureazame_cancel_' + type);

        $.ajax({
            type: 'POST',
            data: { action: 'factureazame_cancel_invoice', type: type, invoice_hash: invoice_hash },
            url: 'admin-ajax.php',
            success: function() {
                if (callback)
                    callback();
                else
                    factureazame_template(type, order_id);
            }
        });
    })(jQuery);
}

function factureazame_issue_bulk(type) {
    (function($) {
        var count = $('input[name="post[]"]:checked').length;

        if (count !== 0) {
            isloading('button_factureazame_issue_bulk_' + type);

            var order_ids = [];
            $($('input[name="post[]"]:checked').get().reverse()).each(function() {
                var order_id = $(this).val();
                // isloading('fme-' + order_id);
                order_ids.push(order_id);
            });

            $.ajax({
                type: 'POST',
                data: { action: 'factureazame_issue_invoices', type: type, order_ids: order_ids },
                url: 'admin-ajax.php',
                dataType: 'json',
                success: function(data) {
                    data.forEach((i) => {
                        $('#fme-' + type + '-' + i.order_id).html(i.html);
                    });
                    $('#button_factureazame_issue_bulk_' + type).removeAttr('disabled', 1).html('Emite facturi fiscale pentru comenzile selectate');
                }
            });
        }
    })(jQuery);
}

Number.prototype.pad = function(size) {
    var s = String(this);
    while (s.length < (size || 2)) {s = "0" + s;}
    return s;
}
