<?php
/*
Plugin Name: factureaza.me - Facturare WooCommerce
Plugin URI: https://www.factureaza.me
Description: Emitere de facturi fiscale in format romanesc pentru comenzile din WooCommerce
Version: 1.19
Author: factureaza.me
License: GPL2
WC tested up to: 6.1
*/

if (!defined('WPINC')) {
    die;
}

if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {

    if (is_admin()) {

        add_action('manage_posts_extra_tablenav', 'factureazame_order_list');
        $s = false;
        function factureazame_order_list($which) {
            if (get_query_var('post_type') == 'shop_order' && $which == 'top') {
                echo '<br class="clear">
                        <div id="factureazame" style="margin-top:20px">
                            <button id="button_factureazame_issue_bulk_invoice" onclick="factureazame_issue_bulk(\'invoice\')" type="button" class="button button-primary">
                                Emite facturi fiscale pentru comenzile selectate
                            </button>
                            '.(!empty(get_option('factureazame_estimates')) ? '
                            <button id="button_factureazame_issue_bulk_estimate" onclick="factureazame_issue_bulk(\'estimate\')" type="button" class="button button-primary">
                                Emite facturi proforme pentru comenzile selectate
                            </button>
                            ' : '').'
                            <script defer>
                                (function($) {
                                    factureazame_check_invoices();
                                    '.(!empty(get_option('factureazame_estimates')) ? 'factureazame_check_invoices(\'estimate\');' : '').'
                                })(jQuery);
                            </script>
                        </div>';
            }
        }

        add_action('woocommerce_admin_order_data_after_order_details', 'factureazame_order_detail');
        function factureazame_order_detail($order) {
            if (isset($_GET['post']) && isset($_GET['action']) && $_GET['action'] == 'edit') {
                echo '<h3 style="clear:both;padding-top:40px;">factureaza.me</h3>
                        <div id="factureazame-invoice" class="form-field form-field-wide">
                            ...
                            <script defer>
                                (function($) {
                                    factureazame_template(\'invoice\', '.$order->get_id().');
                                })(jQuery);
                            </script>
                        </div>
                        '.(!empty(get_option('factureazame_estimates')) ? '
                        <div id="factureazame-estimate" class="form-field form-field-wide">
                            ...
                            <script defer>
                                (function($) {
                                    factureazame_template(\'estimate\', '.$order->get_id().');
                                })(jQuery);
                            </script>
                        </div>
                        ' : '').'';
            }
        }

        add_action('admin_enqueue_scripts', 'factureazame_scripts');
        function factureazame_scripts() {
            wp_enqueue_script(
                'factureazame',
                plugins_url() . '/factureaza-me/factureazame.js',
                array('jquery')
            );
        }

        add_action('admin_init', 'factureazame_register_settings');
        function factureazame_register_settings() {
            add_option('factureazame_apiurl', null);
            register_setting('factureazame_options_group', 'factureazame_apiurl');
            add_option('factureazame_apikey', null);
            register_setting('factureazame_options_group', 'factureazame_apikey');
            add_option('factureazame_company', null);
            register_setting('factureazame_options_group', 'factureazame_company');
            add_option('factureazame_series', 'WOO');
            register_setting('factureazame_options_group', 'factureazame_series');
            add_option('factureazame_number', 1);
            register_setting('factureazame_options_group', 'factureazame_number');
            add_option('factureazame_duedays', 15);
            register_setting('factureazame_options_group', 'factureazame_duedays');
            add_option('factureazame_cashing', false);
            register_setting('factureazame_options_group', 'factureazame_cashing');
            add_option('factureazame_receipt_series', 'CH');
            register_setting('factureazame_options_group', 'factureazame_receipt_series');
            add_option('factureazame_op_series', 'OP');
            register_setting('factureazame_options_group', 'factureazame_op_series');
            add_option('factureazame_estimates', null);
            register_setting('factureazame_options_group', 'factureazame_estimates');
            add_option('factureazame_est-series', 'WOO');
            register_setting('factureazame_options_group', 'factureazame_est-series');
            add_option('factureazame_est-number', 1);
            register_setting('factureazame_options_group', 'factureazame_est-number');

            if (!get_option('factureazame_series')) update_option('factureazame_series', 'WOO');
            if (!get_option('factureazame_number')) update_option('factureazame_number', 1);
            if (!get_option('factureazame_duedays')) update_option('factureazame_duedays', 15);
            if (!get_option('factureazame_cashing')) update_option('factureazame_cashing', false);
            if (!get_option('factureazame_receipt_series')) update_option('factureazame_receipt_series', 'CH');
            if (!get_option('factureazame_op_series')) update_option('factureazame_op_series', 'OP');
            if (!get_option('factureazame_estimates')) update_option('factureazame_estimates', false);
            if (!get_option('factureazame_est-series')) update_option('factureazame_est-series', 'WOO');
            if (!get_option('factureazame_est-number')) update_option('factureazame_est-number', 1);
        }

        add_action('admin_menu', 'factureazame_register_options_page');
        function factureazame_register_options_page() {
            add_options_page('factureaza.me', 'factureaza.me', 'manage_options', 'factureazame', 'factureazame_options_page');
        }
        function factureazame_options_page() {
            ?>
            <div class="wrap">
                <h1>factureaza.me settings</h1>
                <form method="post" action="options.php">
                    <?php settings_fields('factureazame_options_group'); ?>
                    <table class="form-table">
                        <tr>
                            <th scope="row" style="width:320px; text-align:right"><label for="factureazame_apiurl">Adresa API</label></th>
                            <td><input type="text" class="regular-text" style="max-width:210px" id="factureazame_apiurl" name="factureazame_apiurl" value="<?php echo get_option('factureazame_apiurl'); ?>" /></td>
                        </tr>
                        <tr>
                            <th scope="row" style="text-align:right"><label for="factureazame_apikey">Cheie privata API</label></th>
                            <td><input type="text" class="large-text" style="max-width:550px" id="factureazame_apikey" name="factureazame_apikey" value="<?php echo get_option('factureazame_apikey'); ?>" /></td>
                        </tr>
                    </table>
                    <?php
                    if (get_option('factureazame_apiurl') && get_option('factureazame_apikey')) {
                        require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                        $fme = new factureazame();

                        $companies = $fme->CallMethod('company/list');

                        if (isset($companies) && count($companies)) {
                            $find = array_search(get_option('factureazame_company'), array_column($companies, 'Hash'));
                            if ($find === false) {
                                update_option('factureazame_company', $companies[0]['Hash']);
                            }
                            ?>
                            <table class="form-table">
                                <tr><th colspan="2"><hr/></th></tr>

                                <tr>
                                    <th scope="row" style="width:320px; text-align:right"><label for="factureazame_company">Furnizorul</label></th>
                                    <td>
                                        <select class="regular-text" id="factureazame_company" name="factureazame_company">
                                            <?php foreach ($companies as $company) {
                                                if ($company['Hash'] == get_option('factureazame_company')) {
                                                    echo '<option selected="selected" value="'.$company['Hash'].'">'.$company['Name'].'</option>';
                                                } else {
                                                    echo '<option value="'.$company['Hash'].'">'.$company['Name'].'</option>';
                                                }
                                            } ?>
                                        </select>
                                    </td>
                                </tr>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_series">Seria facturilor fiscale</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_series" name="factureazame_series" value="<?php echo get_option('factureazame_series'); ?>" /></td>
                                </tr>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_number">Numarul urmatoarei facturi fiscale emise</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_number" name="factureazame_number" value="<?php echo get_option('factureazame_number'); ?>" /></td>
                                </tr>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_duedays">Scadenta (in zile)</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_duedays" name="factureazame_duedays" value="<?php echo get_option('factureazame_duedays'); ?>" /></td>
                                </tr>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_cashing">Incasare automata</label></th>
                                    <td>
                                        <select class="regular-text" id="factureazame_cashing" name="factureazame_cashing">
                                            <option value="all" <?=get_option('factureazame_cashing')=='all'?'selected="selected"':''?>>Toate comenzile</option>
                                            <option value="receipt" <?=get_option('factureazame_cashing')=='receipt'?'selected="selected"':''?>>Doar chitante - Pentru numerar / COD</option>
                                            <option value="op" <?=get_option('factureazame_cashing')=='op'?'selected="selected"':''?>>Doar ordine de plata - Pentru plata online</option>
                                            <option value="" <?=empty(get_option('factureazame_cashing'))?'selected="selected"':''?>>Dezactivata</option>
                                        </select>
                                    </td>
                                </tr>

                                <?php if (get_option('factureazame_cashing') == 'all' || get_option('factureazame_cashing') == 'receipt') { ?>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_receipt_series">Seria chitantelor</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_receipt_series" name="factureazame_receipt_series" value="<?php echo get_option('factureazame_receipt_series'); ?>" /></td>
                                </tr>
                                <?php } ?>

                                <?php if (get_option('factureazame_cashing') == 'all' || get_option('factureazame_cashing') == 'op') { ?>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_op_series">Seria ordinelor de plata</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_op_series" name="factureazame_op_series" value="<?php echo get_option('factureazame_op_series'); ?>" /></td>
                                </tr>
                                <?php } ?>

                                <tr><th colspan="2"><hr/></th></tr>

                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_estimates">Functionalitate facturi proforme</label></th>
                                    <td>
                                        <select class="regular-text" id="factureazame_estimates" name="factureazame_estimates">
                                            <option value="1" <?=get_option('factureazame_estimates')=='1'?'selected="selected"':''?>>Activata</option>
                                            <option value="" <?=empty(get_option('factureazame_estimates'))?'selected="selected"':''?>>Dezactivata</option>
                                        </select>
                                    </td>
                                </tr>
                                <?php if (get_option('factureazame_estimates') == '1') { ?>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_est-series">Seria facturilor proforme</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_est-series" name="factureazame_est-series" value="<?php echo get_option('factureazame_est-series'); ?>" /></td>
                                </tr>
                                <tr>
                                    <th scope="row" style="text-align:right"><label for="factureazame_est-number">Numarul urmatoarei facturi proforme emise</label></th>
                                    <td><input type="text" class="regular-text" style="max-width:110px" id="factureazame_est-number" name="factureazame_est-number" value="<?php echo get_option('factureazame_est-number'); ?>" /></td>
                                </tr>
                                <?php } ?>
                            </table>
                            <?php
                        } else {
                            update_option('factureazame_company', null);
                        }
                    }
                    ?>
                    <?php submit_button(); ?>
                </form>
            </div>
            <?php
        }

        add_action('wp_ajax_factureazame_template', 'factureazame_template');
        function factureazame_template($ty = 'invoice', $id = null, $sm = null, $found = null) {
            if (is_admin() && wp_doing_ajax()) {
                $type = !empty($ty) ? $ty : $_POST['type'];
                $order_id = !empty($id) ? $id : $_POST['order_id'];
                $slim = !empty($sm) ? $sm : filter_var($_POST['slim'] ?? false, FILTER_VALIDATE_BOOLEAN);

                if ($found === null) {
                    require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                    $fme = new factureazame();

                    $ext = array(get_site_url() . ' WOO' . $order_id);
                    $check = $fme->CallMethod($type . '/check', wp_json_encode($ext), 'POST', array('Content-Type' => 'application/json'));
                    $found = array_filter(
                        $check,
                        function($e) {
                            return $e['Status'] === true;
                        }
                    );
                }

                if (!empty($found))
                {
                    $invoice = array_values($found)[0];

                    if ($slim)
                    $html = '<a href="admin-ajax.php?action=factureazame_view_invoice&type='.$type.'&invoice_hash='.$invoice['Hash'].'" target="_blank" style="margin-right:10px">
                                <div class="dashicons dashicons-paperclip"></div>
                                <strong>'.$invoice['Series'].' '.sprintf("%05d", $invoice['Number']).'</strong>
                            </a>';
                    else
                    $html = '<a id="button_factureazame_view" href="admin-ajax.php?action=factureazame_view_invoice&type='.$type.'&invoice_hash='.$invoice['Hash'].'" target="_blank" class="button  button-primary" style="float:left">
                                Vizualizare '.($type == 'invoice' ? 'factura' : 'proforma').' <strong>'.$invoice['Series'].' '.sprintf("%05d", $invoice['Number']).'</strong>
                            </a>';

                    if ($invoice['Sent'] || in_array($invoice['Hash'], get_option('factureazame_sent', array())))
                    {
                        if ($slim)
                        $html .= '<a href="javascript:;" class="dashicons dashicons-email" style="margin-right:10px; color:#989898" title="Email trimis"></a>';
                        else
                        $html .= '<button type="button" class="button" disabled style="float:left;margin-left:10px">
                                Email trimis
                            </button>';
                    }
                    else
                    {
                        if ($slim)
                        $html .= '<a href="javascript:;" onclick="isloading(\'fme-'.$type.'-'.$order_id.'\'); factureazame_email(\''.$type.'\', \''.$order_id.'\', \''.$invoice['Hash'].'\', function() { factureazame_template(\''.$type.'\', \''.$order_id.'\', true, function(html) { (function($) { $(\'#fme-'.$type.'-'.$order_id.'\').html(html); })(jQuery); }); })" class="dashicons dashicons-email" title="Trimite pe email" style="margin-right:10px"></a>';
                        else
                        $html .= '<button id="button_factureazame_email_'.$type.'" onclick="factureazame_email(\''.$type.'\', \''.$order_id.'\', \''.$invoice['Hash'].'\')" type="button" class="button" style="float:left;margin-left:10px">
                                Trimite pe email
                            </button>';
                    }

                    if ($slim)
                    $html .= '<a href="javascript:;" onclick="isloading(\'fme-'.$type.'-'.$order_id.'\'); factureazame_cancel(\''.$type.'\', \''.$order_id.'\', \''.$invoice['Hash'].'\', function() { factureazame_template(\''.$type.'\', \''.$order_id.'\', true, function(html) { (function($) { $(\'#fme-'.$type.'-'.$order_id.'\').html(html); })(jQuery); }); })" class="dashicons dashicons-trash" title="Anulare"></a>';
                    else
                    $html .= '<button id="button_factureazame_cancel_'.$type.'" onclick="factureazame_cancel(\''.$type.'\', \''.$order_id.'\', \''.$invoice['Hash'].'\')" type="button" class="button" style="float:right">
                                Anulare
                            </button>';
                }
                else
                {
                    if ($slim)
                    $html = '<a href="javascript:;" onclick="isloading(\'fme-'.$type.'-'.$order_id.'\'); factureazame_issue(\''.$type.'\', \''.$order_id.'\', function() { factureazame_template(\''.$type.'\', \''.$order_id.'\', true, function(html) { (function($) { $(\'#fme-'.$type.'-'.$order_id.'\').html(html); })(jQuery); }); })">
                                <div class="dashicons dashicons-plus"></div>
                                <strong>Emite ' . ($type == 'invoice' ? 'fiscala' : 'proforma') . '</strong>
                            </a>';
                    else
                    $html = '<button id="button_factureazame_issue_'.$type.'" onclick="factureazame_issue(\''.$type.'\', \''.$order_id.'\')" type="button" class="button button-primary">
                                Emite factura ' . ($type == 'invoice' ? 'fiscala' : 'proforma') . '
                            </button>';
                }

                if ($id)
                    return $html;
                else
                    echo $html;

                wp_die();
            }
        }

        add_action('wp_ajax_factureazame_template_bulk', 'factureazame_template_bulk');
        function factureazame_template_bulk() {
            if (is_admin() && wp_doing_ajax()) {
                $type = $_POST['type'] ?? 'invoice';
                $order_ids = $_POST['order_ids'];

                require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                $fme = new factureazame();

                $ext = array();
                foreach($order_ids as $order_id) {
                    $ext[$order_id] = get_site_url() . ' WOO' . $order_id;
                }
                $check = $fme->CallMethod($type . '/check', wp_json_encode(array_values($ext)), 'POST', array('Content-Type' => 'application/json'));
                $invoices = array();
                foreach ($check as $invoice) {
                    $invoices[array_flip($ext)[$invoice['ExtID']]] = $invoice;
                }

                $data = array();
                foreach ($order_ids as $order_id) {
                    if (isset($invoices[$order_id])) {
                        $invoice = $invoices[$order_id];
                        if ($invoice['Status'] === true) {
                            $data[] = [
                                'order_id' => $order_id,
                                'html' => factureazame_template($type, $order_id, true, array($invoice))
                            ];
                            continue;
                        }
                    }

                    $data[] = [
                        'order_id' => $order_id,
                        'html' => factureazame_template($type, $order_id, true, 0)
                    ];
                }

                echo wp_json_encode($data);
                wp_die();
            }
        }

        add_action('wp_ajax_factureazame_issue_invoices', 'factureazame_issue_invoices');
        function factureazame_issue_invoices() {
            if (is_admin() && wp_doing_ajax()) {
                $type = $_POST['type'];
                $order_ids = $_POST['order_ids'];
                echo factureazame_ISSUE($type, $order_ids);
                wp_die();
            }
        }
        function factureazame_ISSUE($type, $order_ids) {
            require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
            $fme = new factureazame();

            $ext = array();
            foreach($order_ids as $order_id) {
                $ext[$order_id] = get_site_url() . ' WOO' . $order_id;
            }
            $check = $fme->CallMethod($type . '/check', wp_json_encode(array_values($ext)), 'POST', array('Content-Type' => 'application/json'));

            $found = array();
            foreach ($check as $invoice) {
                if ($invoice['Status'] === true)
                    $found[] = array_flip($ext)[$invoice['ExtID']];
            }

            $results = array();
            $diff = array_values(array_diff($order_ids, $found));
            $todo = array_unique($diff);
            asort($todo);

            $orders = array();
            foreach($todo as $order_id) {
                $order = wc_get_order($order_id);
                $orders[$order->order_date . $order->ID] = $order;
            }
            ksort($orders);

            foreach($orders as $order) {
                $products = $order->get_items();
                $fees = $order->get_items('fee');

                $data = [
                    'Company' => [
                        'Hash' => get_option('factureazame_company')
                    ],
                    'Client' => [
                        'Name' => htmlspecialchars_decode(trim($order->get_billing_company()) != '' ? trim($order->get_billing_company()) : trim($order->get_formatted_billing_full_name())),
                        'VatCode' => htmlspecialchars_decode('-'),
                        'RegCom' => htmlspecialchars_decode('-'),
                        'Country' => htmlspecialchars_decode(trim($order->get_billing_country())),
                        'County' => htmlspecialchars_decode(trim($order->get_billing_state())),
                        'City' => htmlspecialchars_decode(trim($order->get_billing_city())),
                        'Address' => htmlspecialchars_decode(trim($order->get_billing_address_1() . ' ' . $order->get_billing_address_2())),
                        'Bank' => '',
                        'Iban' => '',
                        'Email' => trim($order->get_billing_email()),
                        'Phone' => preg_replace('/[^0-9]/', '', trim($order->get_billing_phone()))
                    ],
                    'Series' => $type == 'invoice' ? get_option('factureazame_series') : get_option('factureazame_est-series'),
                    'Number' => $type == 'invoice' ? get_option('factureazame_number') : get_option('factureazame_est-number'),
                    'Currency' => trim($order->get_currency()),
                    'Comment' => '',
                    'IssueDate' => date('Y-m-d', strtotime($order->order_date)),
                    'DueDate' => date('Y-m-d', strtotime($order->order_date . '+' . get_option('factureazame_duedays') . ' days')),
                    // 'DueDate' => date('Y-m-d', strtotime('+'.get_option('factureazame_duedays').' days')),
                    'ExtID' => get_site_url() . ' WOO' . $order->ID
                ];

                if (in_array('facturare-persoana-fizica-sau-juridica/facturare.php', apply_filters('active_plugins', get_option('active_plugins')))) {
                    $data['Client']['VatCode'] = $order->get_meta('av_facturare')['tip_facturare'] == 'pers-jur' ? $order->get_meta('av_facturare')['cui'] : $order->get_meta('av_facturare')['cnp'];
                    $data['Client']['RegCom'] = $order->get_meta('av_facturare')['tip_facturare'] == 'pers-jur' ? $order->get_meta('av_facturare')['nr_reg_com'] : '-';
                }
    
                foreach ($products as $p) {
                    $data['Products'][] = [
                        'Quantity' => $p->get_quantity(),
                        'Name' => htmlspecialchars_decode(trim($p->get_name())),
                        'Code' => wc_get_product($p->get_product_id())->get_sku(),
                        // 'Name' => htmlspecialchars_decode(trim($p->get_name())) . ' ' . ($p->get_variation_id() ? wc_get_product($p->get_variation_id())->get_sku() : wc_get_product($p->get_product_id())->get_sku()),
                        // 'Code' => ($p->get_variation_id() ? wc_get_product($p->get_variation_id())->get_sku() : wc_get_product($p->get_product_id())->get_sku()),
                        'Price' => round($p->get_subtotal() / $p->get_quantity(), 6),
                        'Currency' => trim($order->get_currency()),
                        'MeasuringUnit' => 'buc.',
                        'TaxRate' => round($p->get_subtotal_tax() / $p->get_subtotal(), 2)
                    ];
                }

                foreach ($fees as $f) {
                    if ($f->get_amount() > 0) {
                        $data['Products'][] = [
                            'Quantity' => 1,
                            'Name' => htmlspecialchars_decode(trim($f->get_name())),
                            'Code' => 'fee',
                            'Price' => round($f->get_amount(), 6),
                            'Currency' => trim($order->get_currency()),
                            'MeasuringUnit' => 'buc.',
                            'TaxRate' => round($f->get_total_tax() / $f->get_total(), 2)
                        ];
                    }
                }
    
                if ($order->get_shipping_total() > 0) {
                    $data['Products'][] = [
                        'Quantity' => 1,
                        'Name' => htmlspecialchars_decode(trim($order->get_shipping_method())),
                        'Code' => 'shipping',
                        'Price' => round($order->get_shipping_total(), 6),
                        'Currency' => trim($order->get_currency()),
                        'MeasuringUnit' => 'buc.',
                        'TaxRate' => round($order->get_shipping_tax() / $order->get_shipping_total(), 2)
                    ];
                }
    
                if ($order->get_discount_total() > 0) {
                    $data['Products'][] = [
                        'Quantity' => 1,
                        'Name' => 'Discount: ' . implode('; ', $order->get_used_coupons()),
                        'Code' => 'discount',
                        'Price' => -1 * abs(round($order->get_discount_total(), 6)),
                        'Currency' => trim($order->get_currency()),
                        'MeasuringUnit' => 'buc.',
                        'TaxRate' => round($order->get_discount_tax() / $order->get_discount_total(), 2)
                    ];
                }

                if ($type == 'invoice' &&
                    !empty(get_option('factureazame_cashing')) && (
                        get_option('factureazame_cashing') == 'all'
                        || (get_option('factureazame_cashing') == 'receipt' && $order->get_payment_method() == 'cod')
                        || (get_option('factureazame_cashing') == 'op' && $order->get_payment_method() != 'cod')
                    )) {
                    $cashing = [
                        'Series' => get_option('factureazame_receipt_series'),
                        'Amount' => round(floatval($order->get_total()), 2),
                        'Currency' => trim($order->get_currency())
                    ];

                    if ($order->get_payment_method() == 'cod') {
                        $cashing['Series'] = get_option('factureazame_receipt_series');
                        $cashing['Receipt'] = 'true';
                    } else {
                        $cashing['Series'] = get_option('factureazame_op_series');
                    }

                    $data['Cashings'][] = $cashing;
                }
    
                $hash = $fme->CallMethod($type, $data, 'POST');
                // $fme->CallMethod($type . '/' . $hash . '/email');
                $invoice = $fme->CallMethod($type . '/' . $hash);

                $results[] = [
                    'order_id' => $order->ID,
                    'html' => factureazame_template($type, $order->ID, true, array($invoice))
                ];
            }

            return wp_json_encode($results);
        }

        add_action('wp_ajax_factureazame_view_invoice', 'factureazame_view_invoice');
        function factureazame_view_invoice() {
            if ($invoice_hash = $_GET['invoice_hash']) {
                require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                $fme = new factureazame();

                $type = $_GET['type'];
                $print = $fme->CallMethod($type . '/' . $invoice_hash . '/pdf');
                header('Content-type:application/pdf');
                echo $print;
            }

            wp_die();
        }

        add_action('wp_ajax_factureazame_email_invoice', 'factureazame_email_invoice_wp');
        function factureazame_email_invoice() {
            if (is_admin() && wp_doing_ajax()) {
                $type = $_POST['type'];
                $order_id = $_POST['order_id'];
                $invoice_hash = $_POST['invoice_hash'];

                require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                $fme = new factureazame();

                $subject = urlencode('Factura '.($type == 'invoice' ? 'fiscala' : 'proforma').' comanda #' . $order_id . ' - ' . get_bloginfo('name'));
                $body = urlencode('Buna ziua,<br><br>Va multumim pentru comanda plasata pe ' . get_bloginfo('name') . '.<br>Am emis factura '.($type == 'invoice' ? 'fiscala' : 'proforma').' {2}{3:d5} in valoare de {4:n2} {5}.<br>Documentul in format PDF este atasat acestui email.<br><br>O zi buna,<br>' . get_bloginfo('name'));

                $fme->CallMethod($type . '/' . $invoice_hash . '/email?Subject=' . $subject . '&Body=' . $body);

                wp_die();
            }
        }
        function factureazame_email_invoice_wp() {
            if (is_admin() && wp_doing_ajax()) {
                $type = $_POST['type'];
                $order_id = $_POST['order_id'];
                $invoice_hash = $_POST['invoice_hash'];
                $factureazame_sent = get_option('factureazame_sent', array());

                if (!in_array($invoice_hash, $factureazame_sent)) {
                    require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                    $fme = new factureazame();

                    $order = wc_get_order($order_id);
                    $invoice = $fme->CallMethod($type . '/' . $invoice_hash);

                    $stream = $fme->CallMethod($type . '/' . $invoice_hash . '/pdf');
                    $attachment = wp_upload_dir()['basedir'] . '/' . 'Factura ' . $invoice['Series'] . sprintf('%05d', $invoice['Number']) . '.pdf';
                    file_put_contents($attachment, $stream);

                    $to = $order->get_billing_email();
                    $subject = 'Factura '.($type == 'invoice' ? 'fiscala' : 'proforma').' comanda #' . $order_id . ' - ' . get_bloginfo('name');
                    $message = '<div style="font-size:1em;color:black;font-family:&quot;Segoe UI&quot;,Tahoma,Geneva,Verdana,sans-serif">';
                    $message .= '<h2 style="font-weight:600;font-size:1.4em;color:black;margin:20px 0 14px 0;padding:15px 0 0 0;border-top:1px solid #0c274f">Buna ziua,</h2>';
                    $message .= 'Va multumim pentru comanda plasata pe ' . get_bloginfo('name') . '.<br>Am emis factura '.($type == 'invoice' ? 'fiscala' : 'proforma').' ' . $invoice['Series'] . sprintf('%05d', $invoice['Number']) . ' in valoare de ' . sprintf('%0.2f', $invoice['Total']) . ' ' . $invoice['Currency'] . '.<br>Documentul in format PDF este atasat acestui email.<br><br>O zi buna,<br>' . get_bloginfo('name');
                    $message .= '</div>';
                    $headers = array('Content-Type: text/html; charset=UTF-8');

                    wp_mail($to, $subject, $message, $headers, array($attachment));

                    unlink($attachment);

                    $factureazame_sent[] = $invoice_hash;

                    update_option('factureazame_sent', $factureazame_sent);
                }

                wp_die();
            }
        }

        add_action('wp_ajax_factureazame_cancel_invoice', 'factureazame_cancel_invoice');
        function factureazame_cancel_invoice() {
            if (is_admin() && wp_doing_ajax()) {
                $type = $_POST['type'];
                $invoice_hash = $_POST['invoice_hash'];

                require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                $fme = new factureazame();

                $fme->CallMethod($type . '/' . $invoice_hash, [], 'DELETE');

                wp_die();
            }
        }

        // add_action('woocommerce_order_status_changed', 'factureazame_order_status_changed', 10, 3);
		// function factureazame_order_status_changed($order_id, $old_status, $new_status) {
		// 	if ($new_status == 'depozit-online') {
        //      $type = 'invoice';
		// 		$order_ids = [$order_id];
		// 		factureazame_ISSUE($type, $order_ids);
		// 	}
		// }

    }

    add_shortcode('factura', 'factureazame_invoice_url');
    function factureazame_invoice_url() {
        if (is_wc_endpoint_url('view-order')) {

            global $wp;
            $order_id = absint($wp->query_vars['view-order']);

            require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
            $fme = new factureazame();

            $ext = array(get_site_url() . ' WOO' . $order_id);
            
            $type = 'invoice';
            $check = $fme->CallMethod($type . '/check', wp_json_encode($ext), 'POST', array('Content-Type' => 'application/json'));
            $found = array_filter(
                $check,
                function($e) {
                    return $e['Status'] === true;
                }
            );

            if (empty($found)) {
                $type = 'estimate';
                $check = $fme->CallMethod($type . '/check', wp_json_encode($ext), 'POST', array('Content-Type' => 'application/json'));
                $found = array_filter(
                    $check,
                    function($e) {
                        return $e['Status'] === true;
                    }
                );
            }

            if (!empty($found))
            {
                $invoice = array_values($found)[0];
                return '<a href="/index.php?action=factureazame_view_invoice_client&type='.$type.'&view-order='.$order_id.'" class="btn btn-primary factureazame-factura" target="_blank">Factura '.$invoice['Series'].' '.sprintf("%05d", $invoice['Number']).'</a>';
            }
        }
    }

    add_action('wp', 'factureazame_view_invoice_client');
    function factureazame_view_invoice_client() {
        if (isset($_GET['action'])) {
            $action = $_GET['action'];
            if ($action == 'factureazame_view_invoice_client') {

                global $wp, $woocommerce;
                $order_id = absint($wp->query_vars['view-order']);
                $order = new WC_Order($order_id);
                
                if ($order->get_user_id() == get_current_user_id()) {
                    $type = $wp->query_vars['type'];

                    require_once(plugin_dir_path(__FILE__) . 'factureazame.class.php');
                    $fme = new factureazame();

                    $ext = array(get_site_url() . ' WOO' . $order_id);
                    $check = $fme->CallMethod($type . '/check', wp_json_encode($ext), 'POST', array('Content-Type' => 'application/json'));
                    $found = array_filter(
                        $check,
                        function($e) {
                            return $e['Status'] === true;
                        }
                    );

                    if (!empty($found))
                    {
                        $invoice = array_values($found)[0];
                        $print = $fme->CallMethod($type . '/' . $invoice['Hash'] . '/pdf');
                        header('Content-type:application/pdf');
                        echo $print;

                        wp_die();
                    }
                }
                
            }
        }
    }
}